#include <xc.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>

#include "system.h"

/*  Initialisations des interruptions */
void Init_Interruptions(void)
{
    PIE1bits.RCIE = 1;
    INTCONbits.PEIE = 1;
    INTCONbits.GIE = 1;
}

char buffer[6];
char buffer_ok;

/*  Routines d'interruption */
void interrupt isr(void)
{
/*  Ce code montre le traitement gnral des interruptions.
    Remarquer que l'on utilise pas des blocks spars pour la condition if.
    Mais des blocks else if afin de ne pas gnrer des erreurs temporelles. */  
/*  Chaque flag correspond  une interruption diffrente */
    
    static uint8_t ptr = 0;
    char c;
    
    if (PIR1bits.RCIF)    // Interruption par rception d'un caractre
    {
        if(RCSTAbits.OERR)  // Si Erreur -> relance
        {
            RCSTAbits.CREN = 0;
            RCSTAbits.CREN = 1;
        }
        buffer[ptr] = RCREG;      // La lecture du registre remet  0 le flag RCIF
        buffer_ok = 0;
        if ((buffer[ptr] == 0x0A) || (buffer[ptr] == 0x0D))     /* Fin de ligne ou Retour charriot*/
        {
            buffer[ptr] = '\0';
            ptr = 0;
            buffer_ok = 1;
        }
        else
        {
            ptr++;
        }
        if (buffer[0] == 'C' & buffer[1] == 'L' & buffer[2] == 'R')
            asm("reset");
    }
//    else if (INTCONbits.INTF)            // Interruption par la ligne RBO/INTE
//    {
//        INTCONbits.INTF = 0;
//    }
    else
    {
        /* Unhandled interrupts */
    }
}

uint8_t Data_Rdy_UART(void)
{
    if(buffer_ok)
    {
        buffer_ok = 0;
        return 1;
    }  
    else
        return 0;
}

void Read_Data_UART(char *rx_buffer)
{
    strcpy(rx_buffer,buffer);
}

